/* ProcessWrapper.c generated by valac 0.45.91, the Vala compiler
 * generated from ProcessWrapper.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*- */
/*
 * Copyright (C) 2012 Victor Eduardo <victoreduardm@gmail.com>
 *
 * Cerbere is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Cerbere is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Cerbere; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor,
 * Boston, MA  02110-1301  USA
 *
 * Authors: Victor Eduardo <victoreduardm@gmail.com>
 */

#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <sys/wait.h>
#include <float.h>
#include <math.h>

#define CERBERE_TYPE_PROCESS_WRAPPER (cerbere_process_wrapper_get_type ())
#define CERBERE_PROCESS_WRAPPER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CERBERE_TYPE_PROCESS_WRAPPER, CerbereProcessWrapper))
#define CERBERE_PROCESS_WRAPPER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CERBERE_TYPE_PROCESS_WRAPPER, CerbereProcessWrapperClass))
#define CERBERE_IS_PROCESS_WRAPPER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CERBERE_TYPE_PROCESS_WRAPPER))
#define CERBERE_IS_PROCESS_WRAPPER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CERBERE_TYPE_PROCESS_WRAPPER))
#define CERBERE_PROCESS_WRAPPER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CERBERE_TYPE_PROCESS_WRAPPER, CerbereProcessWrapperClass))

typedef struct _CerbereProcessWrapper CerbereProcessWrapper;
typedef struct _CerbereProcessWrapperClass CerbereProcessWrapperClass;
typedef struct _CerbereProcessWrapperPrivate CerbereProcessWrapperPrivate;
typedef enum  {
	CERBERE_PROCESS_WRAPPER_STATUS_INACTIVE,
	CERBERE_PROCESS_WRAPPER_STATUS_RUNNING,
	CERBERE_PROCESS_WRAPPER_STATUS_TERMINATED
} CerbereProcessWrapperStatus;

#define CERBERE_PROCESS_WRAPPER_TYPE_STATUS (cerbere_process_wrapper_status_get_type ())
enum  {
	CERBERE_PROCESS_WRAPPER_0_PROPERTY,
	CERBERE_PROCESS_WRAPPER_CRASH_COUNT_PROPERTY,
	CERBERE_PROCESS_WRAPPER_COMMAND_PROPERTY,
	CERBERE_PROCESS_WRAPPER_STATUS_PROPERTY,
	CERBERE_PROCESS_WRAPPER_NUM_PROPERTIES
};
static GParamSpec* cerbere_process_wrapper_properties[CERBERE_PROCESS_WRAPPER_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_timer_destroy0(var) ((var == NULL) ? NULL : (var = (g_timer_destroy (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define CERBERE_TYPE_SETTINGS_MANAGER (cerbere_settings_manager_get_type ())
#define CERBERE_SETTINGS_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CERBERE_TYPE_SETTINGS_MANAGER, CerbereSettingsManager))
#define CERBERE_SETTINGS_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CERBERE_TYPE_SETTINGS_MANAGER, CerbereSettingsManagerClass))
#define CERBERE_IS_SETTINGS_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CERBERE_TYPE_SETTINGS_MANAGER))
#define CERBERE_IS_SETTINGS_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CERBERE_TYPE_SETTINGS_MANAGER))
#define CERBERE_SETTINGS_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CERBERE_TYPE_SETTINGS_MANAGER, CerbereSettingsManagerClass))

typedef struct _CerbereSettingsManager CerbereSettingsManager;
typedef struct _CerbereSettingsManagerClass CerbereSettingsManagerClass;
enum  {
	CERBERE_PROCESS_WRAPPER_EXITED_SIGNAL,
	CERBERE_PROCESS_WRAPPER_NUM_SIGNALS
};
static guint cerbere_process_wrapper_signals[CERBERE_PROCESS_WRAPPER_NUM_SIGNALS] = {0};

struct _CerbereProcessWrapper {
	GObject parent_instance;
	CerbereProcessWrapperPrivate * priv;
};

struct _CerbereProcessWrapperClass {
	GObjectClass parent_class;
};

struct _CerbereProcessWrapperPrivate {
	guint _crash_count;
	gchar* _command;
	CerbereProcessWrapperStatus _status;
	GPid pid;
	GTimer* timer;
};

static gint CerbereProcessWrapper_private_offset;
static gpointer cerbere_process_wrapper_parent_class = NULL;

GType cerbere_process_wrapper_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CerbereProcessWrapper, g_object_unref)
GType cerbere_process_wrapper_status_get_type (void) G_GNUC_CONST;
CerbereProcessWrapper* cerbere_process_wrapper_new (const gchar* command);
CerbereProcessWrapper* cerbere_process_wrapper_construct (GType object_type,
                                                          const gchar* command);
static void cerbere_process_wrapper_set_command (CerbereProcessWrapper* self,
                                          const gchar* value);
void cerbere_process_wrapper_reset_crash_count (CerbereProcessWrapper* self);
static void cerbere_process_wrapper_set_crash_count (CerbereProcessWrapper* self,
                                              guint value);
const gchar* cerbere_process_wrapper_get_command (CerbereProcessWrapper* self);
void cerbere_process_wrapper_run_async (CerbereProcessWrapper* self);
CerbereProcessWrapperStatus cerbere_process_wrapper_get_status (CerbereProcessWrapper* self);
static void cerbere_process_wrapper_set_status (CerbereProcessWrapper* self,
                                         CerbereProcessWrapperStatus value);
static void cerbere_process_wrapper_on_process_watch_exit (CerbereProcessWrapper* self,
                                                    GPid pid,
                                                    gint status);
static void _cerbere_process_wrapper_on_process_watch_exit_gchild_watch_func (GPid pid,
                                                                       gint status,
                                                                       gpointer self);
static void cerbere_process_wrapper_terminate (CerbereProcessWrapper* self);
GType cerbere_settings_manager_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CerbereSettingsManager, g_object_unref)
CerbereSettingsManager* cerbere_app_get_settings (void);
guint cerbere_settings_manager_get_crash_time_interval (CerbereSettingsManager* self);
guint cerbere_process_wrapper_get_crash_count (CerbereProcessWrapper* self);
static void g_cclosure_user_marshal_VOID__OBJECT_BOOLEAN (GClosure * closure,
                                                   GValue * return_value,
                                                   guint n_param_values,
                                                   const GValue * param_values,
                                                   gpointer invocation_hint,
                                                   gpointer marshal_data);
static void cerbere_process_wrapper_finalize (GObject * obj);
static void _vala_cerbere_process_wrapper_get_property (GObject * object,
                                                 guint property_id,
                                                 GValue * value,
                                                 GParamSpec * pspec);
static void _vala_cerbere_process_wrapper_set_property (GObject * object,
                                                 guint property_id,
                                                 const GValue * value,
                                                 GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
cerbere_process_wrapper_get_instance_private (CerbereProcessWrapper* self)
{
	return G_STRUCT_MEMBER_P (self, CerbereProcessWrapper_private_offset);
}

GType
cerbere_process_wrapper_status_get_type (void)
{
	static volatile gsize cerbere_process_wrapper_status_type_id__volatile = 0;
	if (g_once_init_enter (&cerbere_process_wrapper_status_type_id__volatile)) {
		static const GEnumValue values[] = {{CERBERE_PROCESS_WRAPPER_STATUS_INACTIVE, "CERBERE_PROCESS_WRAPPER_STATUS_INACTIVE", "inactive"}, {CERBERE_PROCESS_WRAPPER_STATUS_RUNNING, "CERBERE_PROCESS_WRAPPER_STATUS_RUNNING", "running"}, {CERBERE_PROCESS_WRAPPER_STATUS_TERMINATED, "CERBERE_PROCESS_WRAPPER_STATUS_TERMINATED", "terminated"}, {0, NULL, NULL}};
		GType cerbere_process_wrapper_status_type_id;
		cerbere_process_wrapper_status_type_id = g_enum_register_static ("CerbereProcessWrapperStatus", values);
		g_once_init_leave (&cerbere_process_wrapper_status_type_id__volatile, cerbere_process_wrapper_status_type_id);
	}
	return cerbere_process_wrapper_status_type_id__volatile;
}

CerbereProcessWrapper*
cerbere_process_wrapper_construct (GType object_type,
                                   const gchar* command)
{
	CerbereProcessWrapper * self = NULL;
#line 40 "../src/ProcessWrapper.vala"
	g_return_val_if_fail (command != NULL, NULL);
#line 40 "../src/ProcessWrapper.vala"
	self = (CerbereProcessWrapper*) g_object_new (object_type, NULL);
#line 41 "../src/ProcessWrapper.vala"
	cerbere_process_wrapper_set_command (self, command);
#line 40 "../src/ProcessWrapper.vala"
	return self;
#line 181 "ProcessWrapper.c"
}

CerbereProcessWrapper*
cerbere_process_wrapper_new (const gchar* command)
{
#line 40 "../src/ProcessWrapper.vala"
	return cerbere_process_wrapper_construct (CERBERE_TYPE_PROCESS_WRAPPER, command);
#line 189 "ProcessWrapper.c"
}

void
cerbere_process_wrapper_reset_crash_count (CerbereProcessWrapper* self)
{
	const gchar* _tmp0_;
#line 44 "../src/ProcessWrapper.vala"
	g_return_if_fail (self != NULL);
#line 45 "../src/ProcessWrapper.vala"
	cerbere_process_wrapper_set_crash_count (self, (guint) 0);
#line 46 "../src/ProcessWrapper.vala"
	_tmp0_ = self->priv->_command;
#line 46 "../src/ProcessWrapper.vala"
	g_message ("ProcessWrapper.vala:46: Crash count of '%s' has been reset", _tmp0_);
#line 204 "ProcessWrapper.c"
}

static void
_cerbere_process_wrapper_on_process_watch_exit_gchild_watch_func (GPid pid,
                                                                  gint status,
                                                                  gpointer self)
{
#line 92 "../src/ProcessWrapper.vala"
	cerbere_process_wrapper_on_process_watch_exit ((CerbereProcessWrapper*) self, pid, status);
#line 214 "ProcessWrapper.c"
}

void
cerbere_process_wrapper_run_async (CerbereProcessWrapper* self)
{
	const gchar* _tmp0_;
	CerbereProcessWrapperStatus _tmp1_;
	GPid process_id = 0;
	gchar** argvp = NULL;
	gint argvp_length1;
	gint _argvp_size_;
	gchar** _tmp12_;
	gint _tmp12__length1;
	GTimer* _tmp18_;
	GError* _inner_error0_ = NULL;
#line 49 "../src/ProcessWrapper.vala"
	g_return_if_fail (self != NULL);
#line 50 "../src/ProcessWrapper.vala"
	_tmp0_ = self->priv->_command;
#line 50 "../src/ProcessWrapper.vala"
	g_debug ("ProcessWrapper.vala:50: STARTING process: %s", _tmp0_);
#line 52 "../src/ProcessWrapper.vala"
	_tmp1_ = self->priv->_status;
#line 52 "../src/ProcessWrapper.vala"
	if (_tmp1_ == CERBERE_PROCESS_WRAPPER_STATUS_RUNNING) {
#line 240 "ProcessWrapper.c"
		const gchar* _tmp2_;
#line 53 "../src/ProcessWrapper.vala"
		_tmp2_ = self->priv->_command;
#line 53 "../src/ProcessWrapper.vala"
		g_warning ("ProcessWrapper.vala:53: Process %s is already running. Not starting it" \
" again...", _tmp2_);
#line 54 "../src/ProcessWrapper.vala"
		return;
#line 248 "ProcessWrapper.c"
	}
#line 57 "../src/ProcessWrapper.vala"
	process_id = (GPid) -1;
#line 60 "../src/ProcessWrapper.vala"
	argvp = NULL;
#line 60 "../src/ProcessWrapper.vala"
	argvp_length1 = 0;
#line 60 "../src/ProcessWrapper.vala"
	_argvp_size_ = argvp_length1;
#line 258 "ProcessWrapper.c"
	{
		const gchar* _tmp3_;
		gchar** _tmp4_ = NULL;
		gint _tmp5_ = 0;
#line 62 "../src/ProcessWrapper.vala"
		_tmp3_ = self->priv->_command;
#line 62 "../src/ProcessWrapper.vala"
		g_shell_parse_argv (_tmp3_, &_tmp5_, &_tmp4_, &_inner_error0_);
#line 62 "../src/ProcessWrapper.vala"
		argvp = (_vala_array_free (argvp, argvp_length1, (GDestroyNotify) g_free), NULL);
#line 62 "../src/ProcessWrapper.vala"
		argvp = _tmp4_;
#line 62 "../src/ProcessWrapper.vala"
		argvp_length1 = _tmp5_;
#line 62 "../src/ProcessWrapper.vala"
		_argvp_size_ = argvp_length1;
#line 62 "../src/ProcessWrapper.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 62 "../src/ProcessWrapper.vala"
			if (_inner_error0_->domain == G_SHELL_ERROR) {
#line 279 "ProcessWrapper.c"
				goto __catch1_g_shell_error;
			}
#line 62 "../src/ProcessWrapper.vala"
			argvp = (_vala_array_free (argvp, argvp_length1, (GDestroyNotify) g_free), NULL);
#line 62 "../src/ProcessWrapper.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 62 "../src/ProcessWrapper.vala"
			g_clear_error (&_inner_error0_);
#line 62 "../src/ProcessWrapper.vala"
			return;
#line 290 "ProcessWrapper.c"
		}
	}
	goto __finally1;
	__catch1_g_shell_error:
	{
		GError* _error_ = NULL;
		const gchar* _tmp6_;
		GError* _tmp7_;
		const gchar* _tmp8_;
		const gchar* _tmp9_;
		gchar* _tmp10_;
		gchar** _tmp11_;
#line 61 "../src/ProcessWrapper.vala"
		_error_ = _inner_error0_;
#line 61 "../src/ProcessWrapper.vala"
		_inner_error0_ = NULL;
#line 64 "../src/ProcessWrapper.vala"
		_tmp6_ = self->priv->_command;
#line 64 "../src/ProcessWrapper.vala"
		_tmp7_ = _error_;
#line 64 "../src/ProcessWrapper.vala"
		_tmp8_ = _tmp7_->message;
#line 64 "../src/ProcessWrapper.vala"
		g_warning ("ProcessWrapper.vala:64: Not passing any args to %s : %s", _tmp6_, _tmp8_);
#line 65 "../src/ProcessWrapper.vala"
		_tmp9_ = self->priv->_command;
#line 65 "../src/ProcessWrapper.vala"
		_tmp10_ = g_strdup (_tmp9_);
#line 65 "../src/ProcessWrapper.vala"
		_tmp11_ = g_new0 (gchar*, 2 + 1);
#line 65 "../src/ProcessWrapper.vala"
		_tmp11_[0] = _tmp10_;
#line 65 "../src/ProcessWrapper.vala"
		_tmp11_[1] = NULL;
#line 65 "../src/ProcessWrapper.vala"
		argvp = (_vala_array_free (argvp, argvp_length1, (GDestroyNotify) g_free), NULL);
#line 65 "../src/ProcessWrapper.vala"
		argvp = _tmp11_;
#line 65 "../src/ProcessWrapper.vala"
		argvp_length1 = 2;
#line 65 "../src/ProcessWrapper.vala"
		_argvp_size_ = argvp_length1;
#line 61 "../src/ProcessWrapper.vala"
		_g_error_free0 (_error_);
#line 335 "ProcessWrapper.c"
	}
	__finally1:
#line 61 "../src/ProcessWrapper.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 61 "../src/ProcessWrapper.vala"
		argvp = (_vala_array_free (argvp, argvp_length1, (GDestroyNotify) g_free), NULL);
#line 61 "../src/ProcessWrapper.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 61 "../src/ProcessWrapper.vala"
		g_clear_error (&_inner_error0_);
#line 61 "../src/ProcessWrapper.vala"
		return;
#line 348 "ProcessWrapper.c"
	}
#line 68 "../src/ProcessWrapper.vala"
	_tmp12_ = argvp;
#line 68 "../src/ProcessWrapper.vala"
	_tmp12__length1 = argvp_length1;
#line 68 "../src/ProcessWrapper.vala"
	if (_tmp12_ == NULL) {
#line 69 "../src/ProcessWrapper.vala"
		argvp = (_vala_array_free (argvp, argvp_length1, (GDestroyNotify) g_free), NULL);
#line 69 "../src/ProcessWrapper.vala"
		return;
#line 360 "ProcessWrapper.c"
	}
	{
		GSpawnFlags flags = 0U;
		gchar** _tmp13_;
		gint _tmp13__length1;
		GSpawnFlags _tmp14_;
		GPid _tmp15_ = 0;
#line 73 "../src/ProcessWrapper.vala"
		flags = (G_SPAWN_SEARCH_PATH | G_SPAWN_DO_NOT_REAP_CHILD) | G_SPAWN_STDOUT_TO_DEV_NULL;
#line 77 "../src/ProcessWrapper.vala"
		_tmp13_ = argvp;
#line 77 "../src/ProcessWrapper.vala"
		_tmp13__length1 = argvp_length1;
#line 77 "../src/ProcessWrapper.vala"
		_tmp14_ = flags;
#line 77 "../src/ProcessWrapper.vala"
		g_spawn_async (NULL, _tmp13_, NULL, _tmp14_, NULL, NULL, &_tmp15_, &_inner_error0_);
#line 77 "../src/ProcessWrapper.vala"
		process_id = _tmp15_;
#line 77 "../src/ProcessWrapper.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 382 "ProcessWrapper.c"
			goto __catch2_g_error;
		}
	}
	goto __finally2;
	__catch2_g_error:
	{
		GError* err = NULL;
		GError* _tmp16_;
		const gchar* _tmp17_;
#line 72 "../src/ProcessWrapper.vala"
		err = _inner_error0_;
#line 72 "../src/ProcessWrapper.vala"
		_inner_error0_ = NULL;
#line 82 "../src/ProcessWrapper.vala"
		_tmp16_ = err;
#line 82 "../src/ProcessWrapper.vala"
		_tmp17_ = _tmp16_->message;
#line 82 "../src/ProcessWrapper.vala"
		g_warning ("ProcessWrapper.vala:82: %s", _tmp17_);
#line 83 "../src/ProcessWrapper.vala"
		_g_error_free0 (err);
#line 83 "../src/ProcessWrapper.vala"
		argvp = (_vala_array_free (argvp, argvp_length1, (GDestroyNotify) g_free), NULL);
#line 83 "../src/ProcessWrapper.vala"
		return;
#line 408 "ProcessWrapper.c"
	}
	__finally2:
#line 72 "../src/ProcessWrapper.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 72 "../src/ProcessWrapper.vala"
		argvp = (_vala_array_free (argvp, argvp_length1, (GDestroyNotify) g_free), NULL);
#line 72 "../src/ProcessWrapper.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 72 "../src/ProcessWrapper.vala"
		g_clear_error (&_inner_error0_);
#line 72 "../src/ProcessWrapper.vala"
		return;
#line 421 "ProcessWrapper.c"
	}
#line 87 "../src/ProcessWrapper.vala"
	_tmp18_ = g_timer_new ();
#line 87 "../src/ProcessWrapper.vala"
	_g_timer_destroy0 (self->priv->timer);
#line 87 "../src/ProcessWrapper.vala"
	self->priv->timer = _tmp18_;
#line 88 "../src/ProcessWrapper.vala"
	cerbere_process_wrapper_set_status (self, CERBERE_PROCESS_WRAPPER_STATUS_RUNNING);
#line 89 "../src/ProcessWrapper.vala"
	self->priv->pid = process_id;
#line 92 "../src/ProcessWrapper.vala"
	g_child_watch_add_full (G_PRIORITY_DEFAULT_IDLE, self->priv->pid, _cerbere_process_wrapper_on_process_watch_exit_gchild_watch_func, g_object_ref (self), g_object_unref);
#line 49 "../src/ProcessWrapper.vala"
	argvp = (_vala_array_free (argvp, argvp_length1, (GDestroyNotify) g_free), NULL);
#line 437 "ProcessWrapper.c"
}

static void
cerbere_process_wrapper_on_process_watch_exit (CerbereProcessWrapper* self,
                                               GPid pid,
                                               gint status)
{
	const gchar* _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
#line 95 "../src/ProcessWrapper.vala"
	g_return_if_fail (self != NULL);
#line 96 "../src/ProcessWrapper.vala"
	if (pid != self->priv->pid) {
#line 97 "../src/ProcessWrapper.vala"
		return;
#line 454 "ProcessWrapper.c"
	}
#line 99 "../src/ProcessWrapper.vala"
	_tmp0_ = self->priv->_command;
#line 99 "../src/ProcessWrapper.vala"
	g_message ("ProcessWrapper.vala:99: Process '%s' watch exit", _tmp0_);
#line 102 "../src/ProcessWrapper.vala"
	if (WIFEXITED (status)) {
#line 102 "../src/ProcessWrapper.vala"
		_tmp2_ = TRUE;
#line 464 "ProcessWrapper.c"
	} else {
#line 102 "../src/ProcessWrapper.vala"
		_tmp2_ = WIFSIGNALED (status);
#line 468 "ProcessWrapper.c"
	}
#line 102 "../src/ProcessWrapper.vala"
	if (_tmp2_) {
#line 102 "../src/ProcessWrapper.vala"
		_tmp1_ = TRUE;
#line 474 "ProcessWrapper.c"
	} else {
#line 102 "../src/ProcessWrapper.vala"
		_tmp1_ = WCOREDUMP (status);
#line 478 "ProcessWrapper.c"
	}
#line 102 "../src/ProcessWrapper.vala"
	if (_tmp1_) {
#line 103 "../src/ProcessWrapper.vala"
		cerbere_process_wrapper_terminate (self);
#line 484 "ProcessWrapper.c"
	}
}

static void
cerbere_process_wrapper_terminate (CerbereProcessWrapper* self)
{
	CerbereProcessWrapperStatus _tmp0_;
	const gchar* _tmp1_;
	gboolean normal_exit = FALSE;
	GTimer* _tmp2_;
#line 107 "../src/ProcessWrapper.vala"
	g_return_if_fail (self != NULL);
#line 108 "../src/ProcessWrapper.vala"
	_tmp0_ = self->priv->_status;
#line 108 "../src/ProcessWrapper.vala"
	if (_tmp0_ != CERBERE_PROCESS_WRAPPER_STATUS_RUNNING) {
#line 109 "../src/ProcessWrapper.vala"
		return;
#line 503 "ProcessWrapper.c"
	}
#line 111 "../src/ProcessWrapper.vala"
	_tmp1_ = self->priv->_command;
#line 111 "../src/ProcessWrapper.vala"
	g_message ("ProcessWrapper.vala:111: Process %s is being terminated", _tmp1_);
#line 113 "../src/ProcessWrapper.vala"
	g_spawn_close_pid (self->priv->pid);
#line 115 "../src/ProcessWrapper.vala"
	normal_exit = TRUE;
#line 117 "../src/ProcessWrapper.vala"
	_tmp2_ = self->priv->timer;
#line 117 "../src/ProcessWrapper.vala"
	if (_tmp2_ != NULL) {
#line 517 "ProcessWrapper.c"
		GTimer* _tmp3_;
		gdouble elapsed_secs = 0.0;
		GTimer* _tmp4_;
		gdouble crash_time_interval_secs = 0.0;
		CerbereSettingsManager* _tmp5_;
		CerbereSettingsManager* _tmp6_;
		guint _tmp7_;
		guint _tmp8_;
#line 118 "../src/ProcessWrapper.vala"
		_tmp3_ = self->priv->timer;
#line 118 "../src/ProcessWrapper.vala"
		g_timer_stop (_tmp3_);
#line 120 "../src/ProcessWrapper.vala"
		_tmp4_ = self->priv->timer;
#line 120 "../src/ProcessWrapper.vala"
		elapsed_secs = g_timer_elapsed (_tmp4_, NULL);
#line 121 "../src/ProcessWrapper.vala"
		_tmp5_ = cerbere_app_get_settings ();
#line 121 "../src/ProcessWrapper.vala"
		_tmp6_ = _tmp5_;
#line 121 "../src/ProcessWrapper.vala"
		_tmp7_ = cerbere_settings_manager_get_crash_time_interval (_tmp6_);
#line 121 "../src/ProcessWrapper.vala"
		_tmp8_ = _tmp7_;
#line 121 "../src/ProcessWrapper.vala"
		crash_time_interval_secs = ((gdouble) _tmp8_) / 1000.0;
#line 123 "../src/ProcessWrapper.vala"
		g_message ("ProcessWrapper.vala:123: ET = %f secs\tMin allowed time = %f", elapsed_secs, crash_time_interval_secs);
#line 125 "../src/ProcessWrapper.vala"
		if (elapsed_secs <= crash_time_interval_secs) {
#line 548 "ProcessWrapper.c"
			guint _tmp9_;
			const gchar* _tmp10_;
			guint _tmp11_;
#line 126 "../src/ProcessWrapper.vala"
			_tmp9_ = self->priv->_crash_count;
#line 126 "../src/ProcessWrapper.vala"
			cerbere_process_wrapper_set_crash_count (self, _tmp9_ + 1);
#line 127 "../src/ProcessWrapper.vala"
			normal_exit = FALSE;
#line 128 "../src/ProcessWrapper.vala"
			_tmp10_ = self->priv->_command;
#line 128 "../src/ProcessWrapper.vala"
			_tmp11_ = self->priv->_crash_count;
#line 128 "../src/ProcessWrapper.vala"
			g_warning ("ProcessWrapper.vala:128: PROCESS '%s' CRASHED (#%u)", _tmp10_, _tmp11_);
#line 564 "ProcessWrapper.c"
		}
#line 132 "../src/ProcessWrapper.vala"
		_g_timer_destroy0 (self->priv->timer);
#line 132 "../src/ProcessWrapper.vala"
		self->priv->timer = NULL;
#line 570 "ProcessWrapper.c"
	}
#line 135 "../src/ProcessWrapper.vala"
	cerbere_process_wrapper_set_status (self, CERBERE_PROCESS_WRAPPER_STATUS_TERMINATED);
#line 138 "../src/ProcessWrapper.vala"
	g_signal_emit (self, cerbere_process_wrapper_signals[CERBERE_PROCESS_WRAPPER_EXITED_SIGNAL], 0, self, normal_exit);
#line 576 "ProcessWrapper.c"
}

guint
cerbere_process_wrapper_get_crash_count (CerbereProcessWrapper* self)
{
	guint result;
#line 33 "../src/ProcessWrapper.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 33 "../src/ProcessWrapper.vala"
	result = self->priv->_crash_count;
#line 33 "../src/ProcessWrapper.vala"
	return result;
#line 589 "ProcessWrapper.c"
}

static void
cerbere_process_wrapper_set_crash_count (CerbereProcessWrapper* self,
                                         guint value)
{
#line 33 "../src/ProcessWrapper.vala"
	g_return_if_fail (self != NULL);
#line 33 "../src/ProcessWrapper.vala"
	if (cerbere_process_wrapper_get_crash_count (self) != value) {
#line 33 "../src/ProcessWrapper.vala"
		self->priv->_crash_count = value;
#line 33 "../src/ProcessWrapper.vala"
		g_object_notify_by_pspec ((GObject *) self, cerbere_process_wrapper_properties[CERBERE_PROCESS_WRAPPER_CRASH_COUNT_PROPERTY]);
#line 604 "ProcessWrapper.c"
	}
}

const gchar*
cerbere_process_wrapper_get_command (CerbereProcessWrapper* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 34 "../src/ProcessWrapper.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 34 "../src/ProcessWrapper.vala"
	_tmp0_ = self->priv->_command;
#line 34 "../src/ProcessWrapper.vala"
	result = _tmp0_;
#line 34 "../src/ProcessWrapper.vala"
	return result;
#line 621 "ProcessWrapper.c"
}

static void
cerbere_process_wrapper_set_command (CerbereProcessWrapper* self,
                                     const gchar* value)
{
#line 34 "../src/ProcessWrapper.vala"
	g_return_if_fail (self != NULL);
#line 34 "../src/ProcessWrapper.vala"
	if (g_strcmp0 (value, cerbere_process_wrapper_get_command (self)) != 0) {
#line 632 "ProcessWrapper.c"
		gchar* _tmp0_;
#line 34 "../src/ProcessWrapper.vala"
		_tmp0_ = g_strdup (value);
#line 34 "../src/ProcessWrapper.vala"
		_g_free0 (self->priv->_command);
#line 34 "../src/ProcessWrapper.vala"
		self->priv->_command = _tmp0_;
#line 34 "../src/ProcessWrapper.vala"
		g_object_notify_by_pspec ((GObject *) self, cerbere_process_wrapper_properties[CERBERE_PROCESS_WRAPPER_COMMAND_PROPERTY]);
#line 642 "ProcessWrapper.c"
	}
}

CerbereProcessWrapperStatus
cerbere_process_wrapper_get_status (CerbereProcessWrapper* self)
{
	CerbereProcessWrapperStatus result;
	CerbereProcessWrapperStatus _tmp0_;
#line 35 "../src/ProcessWrapper.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 35 "../src/ProcessWrapper.vala"
	_tmp0_ = self->priv->_status;
#line 35 "../src/ProcessWrapper.vala"
	result = _tmp0_;
#line 35 "../src/ProcessWrapper.vala"
	return result;
#line 659 "ProcessWrapper.c"
}

static void
cerbere_process_wrapper_set_status (CerbereProcessWrapper* self,
                                    CerbereProcessWrapperStatus value)
{
#line 35 "../src/ProcessWrapper.vala"
	g_return_if_fail (self != NULL);
#line 35 "../src/ProcessWrapper.vala"
	if (cerbere_process_wrapper_get_status (self) != value) {
#line 35 "../src/ProcessWrapper.vala"
		self->priv->_status = value;
#line 35 "../src/ProcessWrapper.vala"
		g_object_notify_by_pspec ((GObject *) self, cerbere_process_wrapper_properties[CERBERE_PROCESS_WRAPPER_STATUS_PROPERTY]);
#line 674 "ProcessWrapper.c"
	}
}

static void
g_cclosure_user_marshal_VOID__OBJECT_BOOLEAN (GClosure * closure,
                                              GValue * return_value,
                                              guint n_param_values,
                                              const GValue * param_values,
                                              gpointer invocation_hint,
                                              gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_BOOLEAN) (gpointer data1, gpointer arg_1, gboolean arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_BOOLEAN callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 23 "../src/ProcessWrapper.vala"
	g_return_if_fail (n_param_values == 3);
#line 23 "../src/ProcessWrapper.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 23 "../src/ProcessWrapper.vala"
		data1 = closure->data;
#line 23 "../src/ProcessWrapper.vala"
		data2 = param_values->data[0].v_pointer;
#line 700 "ProcessWrapper.c"
	} else {
#line 23 "../src/ProcessWrapper.vala"
		data1 = param_values->data[0].v_pointer;
#line 23 "../src/ProcessWrapper.vala"
		data2 = closure->data;
#line 706 "ProcessWrapper.c"
	}
#line 23 "../src/ProcessWrapper.vala"
	callback = (GMarshalFunc_VOID__OBJECT_BOOLEAN) (marshal_data ? marshal_data : cc->callback);
#line 23 "../src/ProcessWrapper.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_boolean (param_values + 2), data2);
#line 712 "ProcessWrapper.c"
}

static void
cerbere_process_wrapper_class_init (CerbereProcessWrapperClass * klass,
                                    gpointer klass_data)
{
#line 23 "../src/ProcessWrapper.vala"
	cerbere_process_wrapper_parent_class = g_type_class_peek_parent (klass);
#line 23 "../src/ProcessWrapper.vala"
	g_type_class_adjust_private_offset (klass, &CerbereProcessWrapper_private_offset);
#line 23 "../src/ProcessWrapper.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_cerbere_process_wrapper_get_property;
#line 23 "../src/ProcessWrapper.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_cerbere_process_wrapper_set_property;
#line 23 "../src/ProcessWrapper.vala"
	G_OBJECT_CLASS (klass)->finalize = cerbere_process_wrapper_finalize;
#line 23 "../src/ProcessWrapper.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CERBERE_PROCESS_WRAPPER_CRASH_COUNT_PROPERTY, cerbere_process_wrapper_properties[CERBERE_PROCESS_WRAPPER_CRASH_COUNT_PROPERTY] = g_param_spec_uint ("crash-count", "crash-count", "crash-count", 0, G_MAXUINT, (guint) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 23 "../src/ProcessWrapper.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CERBERE_PROCESS_WRAPPER_COMMAND_PROPERTY, cerbere_process_wrapper_properties[CERBERE_PROCESS_WRAPPER_COMMAND_PROPERTY] = g_param_spec_string ("command", "command", "command", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 23 "../src/ProcessWrapper.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CERBERE_PROCESS_WRAPPER_STATUS_PROPERTY, cerbere_process_wrapper_properties[CERBERE_PROCESS_WRAPPER_STATUS_PROPERTY] = g_param_spec_enum ("status", "status", "status", CERBERE_PROCESS_WRAPPER_TYPE_STATUS, CERBERE_PROCESS_WRAPPER_STATUS_INACTIVE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 23 "../src/ProcessWrapper.vala"
	cerbere_process_wrapper_signals[CERBERE_PROCESS_WRAPPER_EXITED_SIGNAL] = g_signal_new ("exited", CERBERE_TYPE_PROCESS_WRAPPER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_BOOLEAN, G_TYPE_NONE, 2, CERBERE_TYPE_PROCESS_WRAPPER, G_TYPE_BOOLEAN);
#line 737 "ProcessWrapper.c"
}

static void
cerbere_process_wrapper_instance_init (CerbereProcessWrapper * self,
                                       gpointer klass)
{
	gchar* _tmp0_;
#line 23 "../src/ProcessWrapper.vala"
	self->priv = cerbere_process_wrapper_get_instance_private (self);
#line 33 "../src/ProcessWrapper.vala"
	self->priv->_crash_count = (guint) 0;
#line 34 "../src/ProcessWrapper.vala"
	_tmp0_ = g_strdup ("");
#line 34 "../src/ProcessWrapper.vala"
	self->priv->_command = _tmp0_;
#line 35 "../src/ProcessWrapper.vala"
	self->priv->_status = CERBERE_PROCESS_WRAPPER_STATUS_INACTIVE;
#line 37 "../src/ProcessWrapper.vala"
	self->priv->pid = (GPid) -1;
#line 38 "../src/ProcessWrapper.vala"
	self->priv->timer = NULL;
#line 759 "ProcessWrapper.c"
}

static void
cerbere_process_wrapper_finalize (GObject * obj)
{
	CerbereProcessWrapper * self;
#line 23 "../src/ProcessWrapper.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CERBERE_TYPE_PROCESS_WRAPPER, CerbereProcessWrapper);
#line 34 "../src/ProcessWrapper.vala"
	_g_free0 (self->priv->_command);
#line 38 "../src/ProcessWrapper.vala"
	_g_timer_destroy0 (self->priv->timer);
#line 23 "../src/ProcessWrapper.vala"
	G_OBJECT_CLASS (cerbere_process_wrapper_parent_class)->finalize (obj);
#line 774 "ProcessWrapper.c"
}

GType
cerbere_process_wrapper_get_type (void)
{
	static volatile gsize cerbere_process_wrapper_type_id__volatile = 0;
	if (g_once_init_enter (&cerbere_process_wrapper_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (CerbereProcessWrapperClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) cerbere_process_wrapper_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (CerbereProcessWrapper), 0, (GInstanceInitFunc) cerbere_process_wrapper_instance_init, NULL };
		GType cerbere_process_wrapper_type_id;
		cerbere_process_wrapper_type_id = g_type_register_static (G_TYPE_OBJECT, "CerbereProcessWrapper", &g_define_type_info, 0);
		CerbereProcessWrapper_private_offset = g_type_add_instance_private (cerbere_process_wrapper_type_id, sizeof (CerbereProcessWrapperPrivate));
		g_once_init_leave (&cerbere_process_wrapper_type_id__volatile, cerbere_process_wrapper_type_id);
	}
	return cerbere_process_wrapper_type_id__volatile;
}

static void
_vala_cerbere_process_wrapper_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec)
{
	CerbereProcessWrapper * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, CERBERE_TYPE_PROCESS_WRAPPER, CerbereProcessWrapper);
#line 23 "../src/ProcessWrapper.vala"
	switch (property_id) {
#line 23 "../src/ProcessWrapper.vala"
		case CERBERE_PROCESS_WRAPPER_CRASH_COUNT_PROPERTY:
#line 23 "../src/ProcessWrapper.vala"
		g_value_set_uint (value, cerbere_process_wrapper_get_crash_count (self));
#line 23 "../src/ProcessWrapper.vala"
		break;
#line 23 "../src/ProcessWrapper.vala"
		case CERBERE_PROCESS_WRAPPER_COMMAND_PROPERTY:
#line 23 "../src/ProcessWrapper.vala"
		g_value_set_string (value, cerbere_process_wrapper_get_command (self));
#line 23 "../src/ProcessWrapper.vala"
		break;
#line 23 "../src/ProcessWrapper.vala"
		case CERBERE_PROCESS_WRAPPER_STATUS_PROPERTY:
#line 23 "../src/ProcessWrapper.vala"
		g_value_set_enum (value, cerbere_process_wrapper_get_status (self));
#line 23 "../src/ProcessWrapper.vala"
		break;
#line 819 "ProcessWrapper.c"
		default:
#line 23 "../src/ProcessWrapper.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../src/ProcessWrapper.vala"
		break;
#line 825 "ProcessWrapper.c"
	}
}

static void
_vala_cerbere_process_wrapper_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec)
{
	CerbereProcessWrapper * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, CERBERE_TYPE_PROCESS_WRAPPER, CerbereProcessWrapper);
#line 23 "../src/ProcessWrapper.vala"
	switch (property_id) {
#line 23 "../src/ProcessWrapper.vala"
		case CERBERE_PROCESS_WRAPPER_CRASH_COUNT_PROPERTY:
#line 23 "../src/ProcessWrapper.vala"
		cerbere_process_wrapper_set_crash_count (self, g_value_get_uint (value));
#line 23 "../src/ProcessWrapper.vala"
		break;
#line 23 "../src/ProcessWrapper.vala"
		case CERBERE_PROCESS_WRAPPER_COMMAND_PROPERTY:
#line 23 "../src/ProcessWrapper.vala"
		cerbere_process_wrapper_set_command (self, g_value_get_string (value));
#line 23 "../src/ProcessWrapper.vala"
		break;
#line 23 "../src/ProcessWrapper.vala"
		case CERBERE_PROCESS_WRAPPER_STATUS_PROPERTY:
#line 23 "../src/ProcessWrapper.vala"
		cerbere_process_wrapper_set_status (self, g_value_get_enum (value));
#line 23 "../src/ProcessWrapper.vala"
		break;
#line 857 "ProcessWrapper.c"
		default:
#line 23 "../src/ProcessWrapper.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../src/ProcessWrapper.vala"
		break;
#line 863 "ProcessWrapper.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

